//
//    rfnoc-hls-neuralnet: Vivado HLS code for neural-net building blocks
//
//    Copyright (C) 2017 EJ Kreinar
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include <fstream>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "firmware/parameters.h"
#include "firmware/fecpredlite0.h"
#include "nnet_helpers.h"


int main(int argc, char **argv)
{
  //hls-fpga-machine-learning insert data


  bool inputLast[N_INPUT_1_1] = {0,0,0,0,0,0,0,0,0,0,0,0,1};
  //input_t input1[N_INPUT_1_1] = {0,0,0,0,0,0,0,0,0,0,0,0,0};
  //result_t layer9_out[N_LAYER_8] = {0,0};

// output should be 1
  input_t input1[N_INPUT_1_1]=
  {0.5,0.999702,0.999698,0.734689,0.616856,0.279119,0.783993,0.0110688,0.0244955,0.000669056,0.382974,0.626814,0.399};

  //{0.333333,0.999978,0.999977,0.243494,.161826,0.758986,0.0919329,0.41357,0.11095,0.0905804,0.432541,0.000416068,0.364};
  //{0.333333,0.99997,0.999969,0.317812,0.255265,0.90459,0.19834,0.00718755,0.0115273,0.000501779,0.469234,0.0707161,0.356};

  //io_data layer1_in[N_INPUT_1_1];
  conversion_streamtype tmp;
  axis_in layer1_in[N_INPUT_1_1];
  //stream_type layer1_out[N_INPUT_1_1];
  axis_out layerN_out[N_LAYER_6];

  for(int i=0;i<N_INPUT_1_1;i++){
	  (layer1_in[i]).data= input1[i].to_float();
  }

  /*
  for(int i=0;i<N_INPUT_1_1;i++){
	    //tmp.as_float32=input1[i];
      	//layer1_in[i].data=tmp.as_uint32;
	    layer1_in[i].data= uint32(input1[i].to_float()*65536);
      	layer1_in[i].last=inputLast[i];
      }
  stream_type layerN_out[N_LAYER_6];
  */

  //hls-fpga-machine-learning insert top-level-function
  //unsigned short size_in1,size_out1;
  //unsigned short out_class;
  fecpredlite0(layer1_in,layerN_out);

  //hls-fpga-machine-learning insert output
  for(int i = 0; i < N_LAYER_6; i++) {
    std::cout << layerN_out[i].data<< " ";
  }
  //std::cout << out_class <<std::endl;
  std::cout << std::endl;

  return 0;
}
